# skalar_examples: following Mark Harris [2008] in parts

Change the line  'const int N = 100000000'  to change the vector length

### scalar_0
 - #blocks * #threads >= # vector element
 - Only one multiplication per kernel 
 - large array in global memory with kernel results
 - accumulation of kernel results on host
 - GTX 1650:  2.83 GFLOPS
 - A100    : 42.52 GFLOPS

### scalar_1
 - #blocks == # multi-processors on GPU
 - Stepping with large stride through data in kernel 
 - first accumulation step sequentially in one kernel per block
 - accumulation of block results on host
 - GTX 1650:  12.88 GFLOPS
 - A100    : 169.80 GFLOPS

### scalar_2
 - #blocks == # multi-processors on GPU
 - Stepping with large stride through data in kernel 
 - first accumulation step as butterfly per block
 - accumulation of block results on host
 - GTX 1650:  12.90 GFLOPS
 - A100    : 169.87 GFLOPS
 
### scalar_3
 - wrapper with host function 
 - #blocks == # multi-processors on GPU
 - Stepping with large stride through data in kernel 
 - first accumulation step sequentially in one kernel per block
 - second kernel function (one block) to accumulate the above data to one number
 - GTX 1650:  12.70 GFLOPS
 - A100    :  80.70 GFLOPS

### scalar_3_fast
 - checks additionally in dscapr_GPU whether the data have been transferred already.
 - GTX 1650:  12.89 GFLOPS
 - A100    : 180.13 GFLOPS

### scalar_4
 - uses cuBLAS
 - GTX 1650:  12.89 GFLOPS
 - A100    : 173.85 GFLOPS

### scalar_5
 - uses Thrust
 - GTX 1650:  12.89 GFLOPS
 - A100    : 149.36 GFLOPS


 
  
 
 
### cuSOLVERMg (MultiGPU)
Running `./lu_decomposition_cusolvermg {size} {loops} {gpus}`

### MAGMA (Single GPU || MultiGPU)
Running `./lu_decomposition_magma {size} {loops} {gpus}`
